<template>
  <div class="dashboard-transactionss-page pt-3 pb-5">
    <h1 class="page-title">Transactions History</h1>
    <div class="mt-3">
      <!-- <div class="d-flex justify-content-end">
        <button class="btn btn-primary">Download Statement</button>
      </div> -->
      <div class="my-3">
        <div
          class="d-flex flex-wrap align-items-center justify-content-between"
        >
          <div class="d-block my-2">
            <div class="form-group">
              <label class="mb-2">Account From:</label>
              <select
                v-model="form.accountFrom"
                class="form-select"
                v-validate="'required'"
                name="Account From"
              >
                <option
                  v-for="(account, i) in accounts"
                  :key="i"
                  :value="account"
                >
                  {{ `${account.AccountType} - ${account.AccountNumber}` }}
                </option>
              </select>
              <div
                v-show="verrors.has('Account From')"
                class="invalid-feedback"
              >
                {{ verrors.first('Account From') }}
              </div>
            </div>
          </div>
          <div class="d-block my-2">
            <label>Start Date</label>
            <VueDatePicker v-model="startDate"></VueDatePicker>
          </div>
          <div class="d-block my-2">
            <label>End Date</label>
            <VueDatePicker v-model="endDate"></VueDatePicker>
          </div>
          <div class="d-block my-2">
            <vs-button
              :loading="form.active"
              @click="filterTransactions(1, 10)"
            >
              Filter
            </vs-button>
          </div>
          <div class="d-block my-2">
            <vs-button :loading="form.active" @click="generateAccountStatement">
              Generate account Statement
            </vs-button>
          </div>
        </div>
      </div>
      <div class="row mt-3">
        <div class="col-sm-12 col-12">
          <table
            ref="content"
            class="table transactions-table table-borderless position-relative"
          >
            <tr>
              <th v-for="(head, i) in tableHead" :key="i">
                {{ head }}
              </th>
            </tr>
            <tr v-for="(transaction, i) in transactions" :key="i">
              <td class="fw-bold bg-white">{{ i + 1 }}</td>
              <td class="bg-white text-capitalize">
                {{ transaction.name }}
              </td>
              <td class="bg-white text-capitalize">
                {{ transaction.narration }}
              </td>
              <td class="bg-white text=danger fw-bold">
                {{ transaction.amount | formatPrice }}
              </td>
              <!-- <td class="bg-white fw-bold"></td> -->
              <!-- <td class="bg-white">
                <span
                  v-if="transaction.type !== 'debit'"
                  class="badge rounded-pill px-4 py-3 bg-success"
                  >{{ transaction.status }}</span
                >
                <span v-else class="badge rounded-pill px-4 py-3 bg-danger">{{
                  transaction.status
                }}</span>
              </td> -->
              <td class="bg-white fw-bold">
                <span
                  v-if="transaction.type !== 'debit'"
                  class="badge rounded-pill px-4 py-3 bg-success text-capitalize"
                  >{{ transaction.type }}</span
                >
                <span
                  v-else
                  class="badge rounded-pill px-4 py-3 bg-danger text-capitalize"
                  >{{ transaction.type }}</span
                >
              </td>
              <td class="bg-white">
                {{ transaction.createdAt | formatDate }}
                {{ transaction.transactionDate | formatTime }}
              </td>
            </tr>
          </table>
          <div
            v-if="!transactions.length && !contentLoading"
            class="text-center my-3"
          >
            <h3>No transactions History</h3>
          </div>
          <vs-pagination
            v-model="page"
            @click="fetchData(page)"
            :length="totalPages"
          />
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { VueDatePicker } from '@mathieustan/vue-datepicker'
import '@mathieustan/vue-datepicker/dist/vue-datepicker.min.css'

export default {
  components: { VueDatePicker },
  layout: 'dashboard',
  async asyncData({ $axios }) {
    const userAccounts = await $axios.$get('/user/accounts')
    const banks = await $axios.$get('/transaction/banks')
    // console.log(userAccounts.headers)
    return {
      accounts: userAccounts.payload,
      banks: banks.payload.banks,
    }
  },
  data: () => ({
    tableHead: [
      'Transaction ID',
      'Type',
      'Narration',
      'Amount',
      'Type',
      'Date',
    ],
    date: {
      from: new Date(),
    },
    form: {
      active: false,
    },
    page: 1,
    perPage: 10,
    totalPages: 1,
    contentLoading: false,
    transactions: [],
    startDate: new Date(),
    endDate: new Date(),
    filterURL: '',
  }),
  watch: {
    page(value) {
      this.fetchData(value, this.perPage)
    },
  },
  mounted() {
    this.fetchData(this.page, this.perPage)
  },
  created() {
    this.form.accountFrom = this.accounts[0]
  },
  methods: {
    openNotification(position = null, color, message) {
      this.$vs.notification({
        progress: 'auto',
        color,
        position,
        title: message,
        text: '',
      })
    },
    convertDatetoISOString(date) {
      return new Date(date).toISOString()
    },
    async filterTransactions(page, perPage) {
      const loading = this.$vs.loading({
        target: this.$refs.content,
        color: 'primary',
        scale: 2,
      })
      const startDate = this.convertDatetoISOString(this.startDate)
      const endDate = this.convertDatetoISOString(this.endDate)
      this.filterURL = `/transaction/filter?page=${page}&limit=${perPage}&startDate=${startDate}&endDate=${endDate}`
      try {
        this.contentLoading = true
        const response = await this.$axios.$get(this.filterURL)
        console.log(response)
        // ?/transaction/filter?page=1&limit=4&startDate=2021-04-04&endDate=2021-07-04
        loading.close()
        this.transactions = response.payload.data
        this.totalPages = response.payload.totalPages
        this.contentLoading = false
      } catch (error) {
        loading.close()
        this.contentLoading = false
      }
    },
    generateAccountStatement() {
      this.form.active = true
      const data = {
        startDate: this.convertDatetoISOString(this.startDate),
        endDate: this.convertDatetoISOString(this.endDate),
        accountNumber: this.form.accountFrom.AccountNumber,
      }
      this.$axios
        .$post('/user/account-statement', data)
        .then((response) => {
          this.form.active = false
          console.log(response)
          window.location.replace(response.payload)
        })
        .catch((error) => {
          this.form.active = false
          if (
            error.response.status === 404 ||
            error.response.status === 400 ||
            error.response.status === 403 ||
            error.response.status === 406 ||
            error.response.status === 409
          ) {
            console.log(error.response.data)
            this.openNotification(
              'top-left',
              'danger',
              error.response.data.message
            )
          }
        })
    },
    async fetchData(page, perPage) {
      const loading = this.$vs.loading({
        target: this.$refs.content,
        color: 'primary',
        scale: 2,
      })
      const startDate = this.convertDatetoISOString('2000-07-24T22:48:37.709Z')
      const endDate = this.convertDatetoISOString('3000-07-24T22:48:37.709Z')

      this.filterURL = `/transaction/filter?page=${page}&limit=${perPage}&startDate=${startDate}&endDate=${endDate}`

      try {
        this.contentLoading = true
        const response = await this.$axios.$get(this.filterURL)
        loading.close()
        this.transactions = response.payload.data || []
        this.totalPages = response.payload.totalPages || 0
        this.contentLoading = false
      } catch (error) {
        loading.close()
        this.contentLoading = false
      }
    },
  },
}
</script>

<style lang="scss">
@import '~@/assets/scss/index';
@import '~@/assets/scss/variables';

.text-sm {
  font-size: 12px;
}

.dashboard-transactionss-page {
  .transactions-details-card {
    background: #ffffff;
    border-radius: 20px;
    min-height: 300px;
    display: flex;
    align-items: center;
    justify-content: center;
  }
  table {
    th {
      background: rgb(241, 237, 229);
      padding: 20px;
    }
    td {
      padding: 20px;
    }
    th:first-child {
      border-radius: 20px 0px 0px 0px;
    }

    th:last-child {
      border-radius: 0px 20px 0px 0px;
    }
  }
}
</style>
